      PROGRAM BLTEST
*
*     BLAS example code
*
      INCLUDE            'matsize.f'
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*
      CHARACTER*80       MATFILE, RHSFILE, SOLFILE
*
      DOUBLE PRECISION   A( N, N ), B( N, NRHS ), C( N, NRHS )
      DOUBLE PRECISION   WORK( N ), BNORM, CNORM, DLANGE
*
      EXTERNAL           DGESV, DLAPRNT, DLAREAD, DLAWRITE
*
*
      WRITE( 6, * ) '***********************************************'
      WRITE( 6, * ) 'Example of BLAS routine call: (DGEMM)'
      WRITE( 6, * ) 'C = A * B - C' 
      WRITE( 6, * ) '***********************************************'
*
      MATFILE = 'SCAEXMAT.dat'
      RHSFILE = 'SCAEXRHS.dat'
      SOLFILE = 'SCAEXSOL.dat'
*
      CALL DLAREAD( N, N, A, MATFILE )
      CALL DLAREAD( N, NRHS, B, SOLFILE )
      CALL DLAREAD( N, NRHS, C, RHSFILE )
*
      CALL DLAPRNT( N, N, A, 'A', 6 )
      CALL DLAPRNT( N, NRHS, B, 'B', 6 )
*
      CALL DGEMM( 'N', 'N', N, NRHS, N, ONE, A , N, B , N, -ONE, C , N )
*
      CALL DLAPRNT( N, NRHS, C, 'C = A * B - C', 6 )
*
      BNORM = DLANGE( 'I', N, NRHS, B, N, WORK )
      CNORM = DLANGE( 'I', N, NRHS, C, N, WORK )
      WRITE( 6, * ) 
      WRITE( 6, 9998 ) 'B',BNORM,'C',CNORM
 9998 FORMAT('Norm Matrix ',A,':',D15.8) 
*
      STOP
      END
