#include <mpi.h>
#include <iostream>

using namespace std;

int main(int argc, char **argv)
{
  int rnk, sz, n, i;
  double *x, *y, *buff;
  n = atoi(argv[1]);
  
  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rnk);
  MPI_Comm_size(MPI_COMM_WORLD, &sz);
  int chunk = n / sz;
  x = new double [chunk];
  y = new double [chunk];
  if(rnk==0){
    buff = new double [n];
  }

  if(rnk==0) for(i=0; i<n; i++) buff[i] = (double) (i+2);
  MPI_Scatter(&buff[rnk*chunk],chunk,MPI_DOUBLE,x,chunk,MPI_DOUBLE,0,MPI_COMM_WORLD);
  if(rnk==0) for(i=0; i<n; i++) buff[i] = (double) (i*3);
  MPI_Scatter(&buff[rnk*chunk],chunk,MPI_DOUBLE,y,chunk,MPI_DOUBLE,0,MPI_COMM_WORLD);

  for (i=0; i<chunk; i++) x[i] = x[i] + y[i];

  MPI_Gather(x,chunk,MPI_DOUBLE,buff,chunk,MPI_DOUBLE,0,MPI_COMM_WORLD);

  if(rnk==0)
    for(i=0; i<n; i++)
      printf("x[%d] = %6.2f\n",i,buff[i]);
  
  MPI_Finalize();
  return 0;
}

