#include <mpi.h>
#include <iostream>

#define N 100

using namespace std;

int main(int argc, char* argv[])
{
  int rank, size;
  MPI_Init( &argc, &argv );
  MPI_Comm_rank( MPI_COMM_WORLD, &rank);
  MPI_Comm_size( MPI_COMM_WORLD, &size);

  double buf0[N], buf1[N];
  int tag0=157, tag1=158;
  MPI_Status status;
  int tag_of_message, src_of_message;
  if( rank == 0 )
  {
    for(int i=0; i<N; i++)	buf0[i] = 0.1 * (double) i;
    MPI_Send(buf0, N, MPI_DOUBLE, 1, tag0, MPI_COMM_WORLD);
    MPI_Recv(buf1, N, MPI_DOUBLE, 1, tag1, MPI_COMM_WORLD, &status);
    tag_of_message = status.MPI_TAG;
    src_of_message = status.MPI_SOURCE;
    printf( "Hi, this is process %d! I just received a buffer tagged with %d from process %d /buf1[%d] = %f/\n", 
            rank, tag_of_message, src_of_message, N-1, buf1[N-1]);
  }
  else if ( rank == 1 )
  {
    for(int i=0; i<N; i++)	buf1[i] = 0.9 * (double) i;
    MPI_Send(buf1, N, MPI_DOUBLE, 0, tag1, MPI_COMM_WORLD);
    MPI_Recv(buf0, N, MPI_DOUBLE, 0, tag0, MPI_COMM_WORLD, &status);
    tag_of_message = status.MPI_TAG;
    src_of_message = status.MPI_SOURCE;
    printf( "Hi, this is process %d! I just received a buffer tagged with %d from process %d /buf0[%d] = %f/\n", 
            rank, tag_of_message, src_of_message, N-1, buf0[N-1]);
  }
  MPI_Finalize();
  return 0;
}
