#include <cmath>
#include <iostream>

using namespace std;

double f(double x)
{
  return (4.0/(1.0+x*x));
}
int main(int argc, char* argv[])
{
  int i, N=100;
  double delta_x=1.0/(double (N));
  double pi_estimate=0.0;
  double x_;
  for(i=0; i<N; i++)
  {
    x_ = ((double (i))+0.5)*delta_x;
    pi_estimate += f(x_);
  }
  pi_estimate *= delta_x;

  const double pi_exact=3.141592653589793238462643;
  double pi_diff=fabs(pi_exact - pi_estimate);
  printf("pi_exact    = %24.16f\n", pi_exact);
  printf("pi_estimate = %24.16f\n", pi_estimate);
  printf("pi_diff     = %24.16f\n", pi_diff);
  return 0;
}
